﻿using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : TankBarrelBehaviour
    {
		public static void Main()
		{

		ModAPI.Register(
	    new Modification()
	        {
		        OriginalItem = ModAPI.FindSpawnable("Tank"),
		        NameOverride = "M1A2 Abrams Green",
		        NameToOrderByOverride = "!",
		        DescriptionOverride = "M1 Abrams is the main battle tank of the USA, mass-produced since 1980. It is in service with the US Army and Marine Corps",
		        CategoryOverride = ModAPI.FindCategory("Vehicles"),
		        ThumbnailOverride = ModAPI.LoadSprite("Textures/green/Thumbgreen.png"),
		        AfterSpawn = (Instance) =>
		        {
			    //Main
                    Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                    var TankHead = Instance.transform.Find("Head");
                    TankHead.localPosition = new Vector3(0.1f, 1.1f);
                    var TankBody = Instance.transform.Find("Body");
                    var TankBarrel = Instance.transform.Find("Barrel");
                    var TankGasTank = Instance.transform.Find("Gas tank"); 
                    var TankEngine = Instance.transform.Find("Engine");
                    var TankSettings = TankBody.GetComponent<CarBehaviour>();
                    TankSettings.MotorSpeed = -500f;
                    TankSettings.WaterProof = false;
                    


                    //DestroyColliders
                    BoxCollider2D[] boxColliders = TankHead.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders[0]);
                    GameObject.Destroy(boxColliders[1]);
                    GameObject.Destroy(boxColliders[2]);

                    BoxCollider2D[] boxColliders2 = TankBody.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders2[0]);
                    GameObject.Destroy(boxColliders2[1]);
                    GameObject.Destroy(boxColliders2[2]);
                    GameObject.Destroy(boxColliders2[3]);
                    GameObject.Destroy(boxColliders2[4]);

                    //BoxCollider2D[] boxColliders3 = TankBarrel.GetComponents<BoxCollider2D>();
                    //GameObject.Destroy(boxColliders3[0]);
                    TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite(""),
                    };

                    //Tank Head
                    TankBarrel.transform.localScale = new Vector3(1f, 1f, 1f);

                    TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/green/tank tower.png"),
                    };
                    PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                    TankHeadColl.pathCount = 1;
                    TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(1.6314857f,0.184812218f),
                        new Vector2(1.52837765f,0.278122693f),
                        new Vector2(0.441590995f,0.410492361f),
                        new Vector2(0.431270599f,0.553485155f),
                        new Vector2(-0.43660453f,0.55257839f),
                        new Vector2(-0.578489304f,0.379149199f),
                        new Vector2(-0.757416606f,0.37690264f),
                        new Vector2(-0.853400052f,0.263757586f),
                        new Vector2(-2.61639595f,0.265810847f),
                        new Vector2(-2.61716962f,0.318027824f),
                        new Vector2(-2.77894449f,0.319069624f),
                        new Vector2(-2.98050332f,0.0641085505f),
                        new Vector2(-3.14709687f,0.0608592033f),
                        new Vector2(-3.23824358f,-0.134591088f),
                        new Vector2(-3.46509767f,-0.137840196f),
                        new Vector2(-3.46211982f,-0.364678144f),
                        new Vector2(-2.99959159f,-0.465325445f),
                        new Vector2(-2.61677456f,-0.461370319f),
                        new Vector2(-2.53225327f,-0.407977879f),
                        new Vector2(-2.28820467f,-0.660381675f),
                        new Vector2(-1.57422578f,-0.835526586f),
                        new Vector2(3.08029175f,-0.825316548f),
                        new Vector2(3.30741239f,-0.471253693f),
                        new Vector2(3.29403281f,-0.426766813f),
                        new Vector2(2.94575667f,0.0781132281f)
                    });
                    //Body	
                    TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/green/Body.png"),	
                    };
                    PolygonCollider2D TankBodydColl = TankBody.gameObject.AddComponent<PolygonCollider2D>();
                    TankBodydColl.pathCount = 1;
                    TankBodydColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(5.10183191f,0.1574523f),
                        new Vector2(4.86962461f,0.221892983f),
                        new Vector2(3.8361783f,0.299717456f),
                        new Vector2(3.82823563f,0.416426361f),
                        new Vector2(3.59228563f,0.412172019f),
                        new Vector2(3.50473976f,0.307014793f),
                        new Vector2(3.00265193f,0.303972274f),
                        new Vector2(3.00087404f,0.463228405f),
                        new Vector2(2.72420216f,0.46626693f),
                        new Vector2(2.56633377f,0.361793041f),
                        new Vector2(1.91712189f,0.443818569f),
                        new Vector2(2.82774639f,0.595663786f),
                        new Vector2(2.82237482f,0.657660365f),
                        new Vector2(1.6266613f,0.673429012f),
                        new Vector2(-1.47565532f,0.672020793f),
                        new Vector2(-1.48630655f,0.466950178f),
                        new Vector2(-2.74544144f,0.724278927f),
                        new Vector2(-2.77404761f,0.724936962f),
                        new Vector2(-5.0621829f,0.734445095f),
                        new Vector2(-5.14096308f,0.664267242f),
                        new Vector2(-5.11322546f,-0.120576277f),
                        new Vector2(-4.6991663f,-0.124555603f),
                        new Vector2(-3.80587363f,-0.0712018758f),
                        new Vector2(-3.65903807f,-0.216941357f),
                        new Vector2(-3.59791589f,-0.570784509f),
                        new Vector2(4.47447014f,-0.581769407f),
                        new Vector2(4.77418804f,-0.355621606f),
                        new Vector2(5.1103425f,0.0486336984f)
                    });
                    GameObject.Destroy(Instance.transform.GetChild(11).gameObject);
    
                    //Gas Tank
                    Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                    };	
                //Engine
			        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Engine.png"),
                    };	
			    //Wheels
			            Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel1.png"),
                                };

			            Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
               	                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };
			
		                Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                        };

			            Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/green/Wheel1.png"),
                        };

                    //Other
                    Instance.AddComponent<NoChildrenCollide>();
                    NoCollide noCollide = Instance.AddComponent<NoCollide>();
                    noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                    noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();

                    GameObject cannon = ModAPI.CreatePhysicalObject("cannon", ModAPI.LoadSprite("Textures/green/barrel.png"));
                    cannon.transform.SetParent(Instance.transform);
                    GameObject.Destroy(cannon.GetComponent<Collider2D>());
                    cannon.AddComponent<BoxCollider2D>();

                    var Joint2 = cannon.AddComponent<HingeJoint2D>();
                    Joint2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                    Joint2.enableCollision = true;
                    PhysicalBehaviour physicalBehaviour2 = cannon.GetComponent<PhysicalBehaviour>();
                    physicalBehaviour2.Properties = ModAPI.FindPhysicalProperties("Metal");
                    //GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);

                    var shoota = cannon.AddComponent<ProjectileLauncherBehaviour>();
                    if (Instance.transform.lossyScale.x < 0)
                    {
                        cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(5.45f, -0.7f);
                        cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/barrelflop.png");
                        Joint2.anchor = new Vector3(3f, 0f);
                        shoota.projectileAsset = ModAPI.FindSpawnable("Abrams Round flop");
                        HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(4f, 0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        smoke.GetComponent<SpriteRenderer>().sprite = null;
                        smoke.transform.parent = TankBody.transform;

                        GameObject gun = GameObject.Instantiate(ModAPI.FindSpawnable("Light Machine Gun").Prefab, Instance.transform.position + new Vector3(-1f, 1.7f, 0f), Quaternion.identity);
                        gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gun.png");
                        gun.FixColliders();
                        gun.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                        gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                        var firearm = gun.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "7.63×25mm Mauser";
                        customCartridge.Damage *= 32f;
                        customCartridge.StartSpeed *= 10f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
                        customCartridge.Recoil *= 0.4f;
                        customCartridge.ImpactForce *= 10f;
                        firearm.Cartridge = customCartridge;
                        HingeJoint2D hj = gun.AddComponent<HingeJoint2D>();
                        hj.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                        hj.anchor = new Vector2(-0.5f, 0f);
                        gun.transform.localScale = new Vector3(-1f, 1f, 1f);
                        gun.transform.parent = TankHead.transform;

                        JointAngleLimits2D limits = new JointAngleLimits2D();
                        limits.min = 25f;
                        limits.max = -45f;
                        Joint2.limits = limits;

                        JointAngleLimits2D limits1 = new JointAngleLimits2D();
                        limits1.min = 25f;
                        limits1.max = -180f;
                        hj.limits = limits1;
                    }
                    else
                    {
                        cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(-5.45f, -0.7f);
                        cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/barrel.png");
                        Joint2.anchor = new Vector3(-3f, 0f);
                        shoota.projectileAsset = ModAPI.FindSpawnable("Abrams Round");
                        HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(-4f, 0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        smoke.GetComponent<SpriteRenderer>().sprite = null;
                        smoke.transform.parent = TankBody.transform;

                        GameObject gun = GameObject.Instantiate(ModAPI.FindSpawnable("Light Machine Gun").Prefab, Instance.transform.position + new Vector3(0.7f, 1.7f, 0f), Quaternion.identity);
                        gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gun.png");
                        gun.FixColliders();
                        gun.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                        gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                        var firearm = gun.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "7.63×25mm Mauser";
                        customCartridge.Damage *= 32f;
                        customCartridge.StartSpeed *= 10f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
                        customCartridge.Recoil *= 0.4f;
                        customCartridge.ImpactForce *= 10f;
                        firearm.Cartridge = customCartridge;
                        HingeJoint2D hj = gun.AddComponent<HingeJoint2D>();
                        hj.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                        hj.anchor = new Vector2(-0.5f, 0f);
                        gun.transform.parent = TankHead.transform;

                        JointAngleLimits2D limits = new JointAngleLimits2D();
                        limits.min = -45f;
                        limits.max = 25f;
                        Joint2.limits = limits;

                        JointAngleLimits2D limits1 = new JointAngleLimits2D();
                        limits1.min = -180f;
                        limits1.max = 25f;
                        hj.limits = limits1;

                    }
                    JointMotor2D motor = new JointMotor2D();
                    motor.maxMotorTorque = 50;
                    cannon.GetComponent<HingeJoint2D>().motor = motor;
                    JointMotor2D motor2 = new JointMotor2D();
                    motor2.maxMotorTorque = 10;

                    shoota.recoilMultiplier = 2.5f;

                    shoota.ScreenShake = 1337f;
                    shoota.IsAutomatic = true;
                    shoota.AutomaticInterval = 1;
                    shoota.launchSound = ModAPI.LoadSound("sounds/shoot.wav");

                    if (Instance.transform.lossyScale.x < 0)
                    {
                        shoota.projectileLaunchStrength = -15f;
                        shoota.barrelPosition = new Vector2(-8f, 0f);
                    }
                    else
                    {
                        shoota.projectileLaunchStrength = 15f;
                        shoota.barrelPosition = new Vector2(8f, 0f);
                    }

                    var allColliders = Instance.GetComponentsInChildren<Collider2D>();
                    foreach (var a in allColliders)
                        foreach (var b in allColliders)
                            Physics2D.IgnoreCollision(a, b);

                    cannon.AddComponent<fcOnFireGarbage>();
                    var fc = cannon.GetComponent<fcOnFireGarbage>();
                    fc.Cannon = cannon;

                    var Joint3 = TankBodydColl.GetComponent<HingeJoint2D>();

                    Joint3.connectedBody = cannon.GetComponent<Rigidbody2D>();
                    GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);
                }
     }
	    );
            ModAPI.Register(
        new Modification()
        {
            OriginalItem = ModAPI.FindSpawnable("Tank"),
            NameOverride = "M1A2 Abrams sand",
            NameToOrderByOverride = "!",
            DescriptionOverride = "M1 Abrams is the main battle tank of the USA, mass-produced since 1980. It is in service with the US Army and Marine Corps",
            CategoryOverride = ModAPI.FindCategory("Vehicles"),
            ThumbnailOverride = ModAPI.LoadSprite("Textures/sand/Thumbsand.png"),
            AfterSpawn = (Instance) =>
            {
                //Main
                Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                var TankHead = Instance.transform.Find("Head");
                TankHead.localPosition = new Vector3(0.1f, 1.1f);
                var TankBody = Instance.transform.Find("Body");
                var TankBarrel = Instance.transform.Find("Barrel");
                var TankGasTank = Instance.transform.Find("Gas tank");
                var TankEngine = Instance.transform.Find("Engine");
                var TankSettings = TankBody.GetComponent<CarBehaviour>();
                TankSettings.MotorSpeed = -500f;
                TankSettings.WaterProof = false;



                //DestroyColliders
                BoxCollider2D[] boxColliders = TankHead.GetComponents<BoxCollider2D>();
                GameObject.Destroy(boxColliders[0]);
                GameObject.Destroy(boxColliders[1]);
                GameObject.Destroy(boxColliders[2]);

                BoxCollider2D[] boxColliders2 = TankBody.GetComponents<BoxCollider2D>();
                GameObject.Destroy(boxColliders2[0]);
                GameObject.Destroy(boxColliders2[1]);
                GameObject.Destroy(boxColliders2[2]);
                GameObject.Destroy(boxColliders2[3]);
                GameObject.Destroy(boxColliders2[4]);

                //BoxCollider2D[] boxColliders3 = TankBarrel.GetComponents<BoxCollider2D>();
                //GameObject.Destroy(boxColliders3[0]);
                TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                        ModAPI.LoadSprite(""),
                };

                //Tank Head
                TankBarrel.transform.localScale = new Vector3(1f, 1f, 1f);

                TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                        ModAPI.LoadSprite("Textures/sand/tank tower.png"),
                };
                PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                TankHeadColl.pathCount = 1;
                TankHeadColl.SetPath(0, new Vector2[]
                {
                        new Vector2(1.6314857f,0.184812218f),
                        new Vector2(1.52837765f,0.278122693f),
                        new Vector2(0.441590995f,0.410492361f),
                        new Vector2(0.431270599f,0.553485155f),
                        new Vector2(-0.43660453f,0.55257839f),
                        new Vector2(-0.578489304f,0.379149199f),
                        new Vector2(-0.757416606f,0.37690264f),
                        new Vector2(-0.853400052f,0.263757586f),
                        new Vector2(-2.61639595f,0.265810847f),
                        new Vector2(-2.61716962f,0.318027824f),
                        new Vector2(-2.77894449f,0.319069624f),
                        new Vector2(-2.98050332f,0.0641085505f),
                        new Vector2(-3.14709687f,0.0608592033f),
                        new Vector2(-3.23824358f,-0.134591088f),
                        new Vector2(-3.46509767f,-0.137840196f),
                        new Vector2(-3.46211982f,-0.364678144f),
                        new Vector2(-2.99959159f,-0.465325445f),
                        new Vector2(-2.61677456f,-0.461370319f),
                        new Vector2(-2.53225327f,-0.407977879f),
                        new Vector2(-2.28820467f,-0.660381675f),
                        new Vector2(-1.57422578f,-0.835526586f),
                        new Vector2(3.08029175f,-0.825316548f),
                        new Vector2(3.30741239f,-0.471253693f),
                        new Vector2(3.29403281f,-0.426766813f),
                        new Vector2(2.94575667f,0.0781132281f)
                });
                //Body	
                TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                        ModAPI.LoadSprite("Textures/sand/Body.png"),
                };
                PolygonCollider2D TankBodydColl = TankBody.gameObject.AddComponent<PolygonCollider2D>();
                TankBodydColl.pathCount = 1;
                TankBodydColl.SetPath(0, new Vector2[]
                {
                        new Vector2(5.10183191f,0.1574523f),
                        new Vector2(4.86962461f,0.221892983f),
                        new Vector2(3.8361783f,0.299717456f),
                        new Vector2(3.82823563f,0.416426361f),
                        new Vector2(3.59228563f,0.412172019f),
                        new Vector2(3.50473976f,0.307014793f),
                        new Vector2(3.00265193f,0.303972274f),
                        new Vector2(3.00087404f,0.463228405f),
                        new Vector2(2.72420216f,0.46626693f),
                        new Vector2(2.56633377f,0.361793041f),
                        new Vector2(1.91712189f,0.443818569f),
                        new Vector2(2.82774639f,0.595663786f),
                        new Vector2(2.82237482f,0.657660365f),
                        new Vector2(1.6266613f,0.673429012f),
                        new Vector2(-1.47565532f,0.672020793f),
                        new Vector2(-1.48630655f,0.466950178f),
                        new Vector2(-2.74544144f,0.724278927f),
                        new Vector2(-2.77404761f,0.724936962f),
                        new Vector2(-5.0621829f,0.734445095f),
                        new Vector2(-5.14096308f,0.664267242f),
                        new Vector2(-5.11322546f,-0.120576277f),
                        new Vector2(-4.6991663f,-0.124555603f),
                        new Vector2(-3.80587363f,-0.0712018758f),
                        new Vector2(-3.65903807f,-0.216941357f),
                        new Vector2(-3.59791589f,-0.570784509f),
                        new Vector2(4.47447014f,-0.581769407f),
                        new Vector2(4.77418804f,-0.355621606f),
                        new Vector2(5.1103425f,0.0486336984f)
                });
                GameObject.Destroy(Instance.transform.GetChild(11).gameObject);

                //Gas Tank
                Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                };
                //Engine
                Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                        ModAPI.LoadSprite("Textures/Engine.png"),
                };
                //Wheels
                Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel1.png"),
                        };

                Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                           {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                        };

                Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                };

                Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                {
                                    ModAPI.LoadSprite("Textures/sand/Wheel1.png"),
                };

                //Other
                Instance.AddComponent<NoChildrenCollide>();
                NoCollide noCollide = Instance.AddComponent<NoCollide>();
                noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();

                GameObject cannon = ModAPI.CreatePhysicalObject("cannon", ModAPI.LoadSprite("Textures/sand/barrel.png"));
                cannon.transform.SetParent(Instance.transform);
                GameObject.Destroy(cannon.GetComponent<Collider2D>());
                cannon.AddComponent<BoxCollider2D>();

                var Joint2 = cannon.AddComponent<HingeJoint2D>();
                Joint2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                Joint2.enableCollision = true;
                PhysicalBehaviour physicalBehaviour2 = cannon.GetComponent<PhysicalBehaviour>();
                physicalBehaviour2.Properties = ModAPI.FindPhysicalProperties("Metal");
                //GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);

                var shoota = cannon.AddComponent<ProjectileLauncherBehaviour>();
                if (Instance.transform.lossyScale.x < 0)
                {
                    cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(5.45f, -0.7f);
                    cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/barrelflop.png");
                    Joint2.anchor = new Vector3(3f, 0f);
                    shoota.projectileAsset = ModAPI.FindSpawnable("Abrams Round flop");
                    HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(4f, 0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                    smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                    smoke.GetComponent<SpriteRenderer>().sprite = null;
                    smoke.transform.parent = TankBody.transform;

                    GameObject gun = GameObject.Instantiate(ModAPI.FindSpawnable("Light Machine Gun").Prefab, Instance.transform.position + new Vector3(-1f, 1.7f, 0f), Quaternion.identity);
                    gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gun.png");
                    gun.FixColliders();
                    gun.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                    gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                    var firearm = gun.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                    customCartridge.name = "7.63×25mm Mauser";
                    customCartridge.Damage *= 32f;
                    customCartridge.StartSpeed *= 10f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
                    customCartridge.Recoil *= 0.4f;
                    customCartridge.ImpactForce *= 10f;
                    firearm.Cartridge = customCartridge;
                    HingeJoint2D hj = gun.AddComponent<HingeJoint2D>();
                    hj.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                    hj.anchor = new Vector2(-0.5f, 0f);
                    gun.transform.localScale = new Vector3(-1f, 1f, 1f);
                    gun.transform.parent = TankHead.transform;

                    JointAngleLimits2D limits = new JointAngleLimits2D();
                    limits.min = 25f;
                    limits.max = -45f;
                    Joint2.limits = limits;

                    JointAngleLimits2D limits1 = new JointAngleLimits2D();
                    limits1.min = 25f;
                    limits1.max = -180f;
                    hj.limits = limits1;
                }
                else
                {
                    cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(-5.45f, -0.7f);
                    cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/barrel.png");
                    Joint2.anchor = new Vector3(-3f, 0f);
                    shoota.projectileAsset = ModAPI.FindSpawnable("Abrams Round");
                    HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(-4f, 0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                    smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                    smoke.GetComponent<SpriteRenderer>().sprite = null;
                    smoke.transform.parent = TankBody.transform;

                    GameObject gun = GameObject.Instantiate(ModAPI.FindSpawnable("Light Machine Gun").Prefab, Instance.transform.position + new Vector3(0.7f, 1.7f, 0f), Quaternion.identity);
                    gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gun.png");
                    gun.FixColliders();
                    gun.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                    gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                    var firearm = gun.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                    customCartridge.name = "7.63×25mm Mauser";
                    customCartridge.Damage *= 32f;
                    customCartridge.StartSpeed *= 10f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
                    customCartridge.Recoil *= 0.4f;
                    customCartridge.ImpactForce *= 10f;
                    firearm.Cartridge = customCartridge;
                    HingeJoint2D hj = gun.AddComponent<HingeJoint2D>();
                    hj.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                    hj.anchor = new Vector2(-0.5f, 0f);
                    gun.transform.parent = TankHead.transform;

                    JointAngleLimits2D limits = new JointAngleLimits2D();
                    limits.min = -45f;
                    limits.max = 25f;
                    Joint2.limits = limits;

                    JointAngleLimits2D limits1 = new JointAngleLimits2D();
                    limits1.min = -180f;
                    limits1.max = 25f;
                    hj.limits = limits1;

                }
                JointMotor2D motor = new JointMotor2D();
                motor.maxMotorTorque = 50;
                cannon.GetComponent<HingeJoint2D>().motor = motor;
                JointMotor2D motor2 = new JointMotor2D();
                motor2.maxMotorTorque = 10;

                shoota.recoilMultiplier = 2.5f;

                shoota.ScreenShake = 1337f;
                shoota.IsAutomatic = true;
                shoota.AutomaticInterval = 1;
                shoota.launchSound = ModAPI.LoadSound("sounds/shoot.wav");

                if (Instance.transform.lossyScale.x < 0)
                {
                    shoota.projectileLaunchStrength = -15f;
                    shoota.barrelPosition = new Vector2(-8f, 0f);
                }
                else
                {
                    shoota.projectileLaunchStrength = 15f;
                    shoota.barrelPosition = new Vector2(8f, 0f);
                }

                var allColliders = Instance.GetComponentsInChildren<Collider2D>();
                foreach (var a in allColliders)
                    foreach (var b in allColliders)
                        Physics2D.IgnoreCollision(a, b);

                cannon.AddComponent<fcOnFireGarbage>();
                var fc = cannon.GetComponent<fcOnFireGarbage>();
                fc.Cannon = cannon;

                var Joint3 = TankBodydColl.GetComponent<HingeJoint2D>();

                Joint3.connectedBody = cannon.GetComponent<Rigidbody2D>();
                GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);
            }
        }
        );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = "Abrams Round",
                    DescriptionOverride = "A highly fragile explosive round.",
                    CategoryOverride = ModAPI.FindCategory("none"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/shell.png");
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<ExplosiveBehaviour>().Range = 25f;
                        Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 1f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 75;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0.1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 350f;

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = "Abrams Round flop",
                    DescriptionOverride = "A highly fragile explosive round.",
                    CategoryOverride = ModAPI.FindCategory("none"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/shell.png");
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<ExplosiveBehaviour>().Range = 25f;
                        Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 1f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 75;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0.1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 350f;
                        Instance.transform.localScale = new Vector3(-1f, 1f, 1f);

                    }
                }
            );
        }
	}
    public class fcOnFireGarbage : MonoBehaviour
    {
        public GameObject Cannon;
        public Vector3 corner_position_offset;
        public Vector4 corner_position_offset2;

        void Start()
        {
            //ModAPI.Notify("aaa");
            corner_position_offset = new Vector3(0, 0, 0);
            corner_position_offset2 = new Vector3(0, 0, 0);

            if (Cannon.transform.parent.gameObject.transform.lossyScale.x < 0)
            {
                corner_position_offset = new Vector3(-4, 0, 0);
                //ModAPI.Notify("First");
            }
            else
            {
                corner_position_offset = new Vector3(4, 0, 0);
                //ModAPI.Notify("Second");
            }

        }

        void Use()
        {

            ModAPI.CreateParticleEffect("Explosion", Cannon.transform.position + (Cannon.transform.rotation * corner_position_offset));

        }

    }
}

